public static class ComponentIds {
    public const int AnArray = 0;
    public const int AnimationCurve = 1;
    public const int Array2D = 2;
    public const int Array3D = 3;
    public const int Bounds = 4;
    public const int Color = 5;
    public const int CustomObject = 6;
    public const int DateTime = 7;
    public const int DictArray = 8;
    public const int Dictionary = 9;
    public const int GameObject = 10;
    public const int HashSet = 11;
    public const int JaggedArray = 12;
    public const int ListArray = 13;
    public const int List = 14;
    public const int MyBool = 15;
    public const int MyEnum = 16;
    public const int MyFloat = 17;
    public const int MyInt = 18;
    public const int MyString = 19;
    public const int Rect = 20;
    public const int SystemObject = 21;
    public const int UnityObject = 22;
    public const int UnsupportedObject = 23;
    public const int Vector2 = 24;
    public const int Vector3 = 25;
    public const int Vector4 = 26;

    public const int TotalComponents = 27;

    public static readonly string[] componentNames = {
        "AnArray",
        "AnimationCurve",
        "Array2D",
        "Array3D",
        "Bounds",
        "Color",
        "CustomObject",
        "DateTime",
        "DictArray",
        "Dictionary",
        "GameObject",
        "HashSet",
        "JaggedArray",
        "ListArray",
        "List",
        "MyBool",
        "MyEnum",
        "MyFloat",
        "MyInt",
        "MyString",
        "Rect",
        "SystemObject",
        "UnityObject",
        "UnsupportedObject",
        "Vector2",
        "Vector3",
        "Vector4"
    };

    public static readonly System.Type[] componentTypes = {
        typeof(AnArrayComponent),
        typeof(AnimationCurveComponent),
        typeof(Array2DComponent),
        typeof(Array3DComponent),
        typeof(BoundsComponent),
        typeof(ColorComponent),
        typeof(CustomObjectComponent),
        typeof(DateTimeComponent),
        typeof(DictArrayComponent),
        typeof(DictionaryComponent),
        typeof(GameObjectComponent),
        typeof(HashSetComponent),
        typeof(JaggedArrayComponent),
        typeof(ListArrayComponent),
        typeof(ListComponent),
        typeof(MyBoolComponent),
        typeof(MyEnumComponent),
        typeof(MyFloatComponent),
        typeof(MyIntComponent),
        typeof(MyStringComponent),
        typeof(RectComponent),
        typeof(SystemObjectComponent),
        typeof(UnityObjectComponent),
        typeof(UnsupportedObjectComponent),
        typeof(Vector2Component),
        typeof(Vector3Component),
        typeof(Vector4Component)
    };
}